import pyglet, random
pyglet.options['debug_gl'] = False
from pyglet.window import key
from tools import info_X_Y
from sprites import game_Logo, map_Block, flyer_s, commit_buttom, clear_buttom, empty_buttom
from graphics2d import draw_rect, draw_line
from question_and_answer import question_and_answer

class numberWindow(pyglet.window.Window):
    def __init__(self, *args, **kwargs):
        super(numberWindow, self).__init__(800, 600, caption="Hello World")
        
        self.batch = pyglet.graphics.Batch()
        self.game_start_batch = pyglet.graphics.Batch()

        self.start_x = 2
        self.start_y = 2
        self.hit = 0
        self.flyer_alive = 0
        self.start_game = 0
        self.level = 1
        self.q_a = 0
        self.score = 0
        
        self.label = pyglet.text.Label('Kill         H1N1',
            font_name='Time New Roman',
            font_size=40,
            x=self.width//2, y=self.height//2,
            anchor_x='center', anchor_y='center', batch=self.game_start_batch)
            
        self.viruses_logo = flyer_s()
        self.viruses_logo.x = self.width//2
        self.viruses_logo.y = self.height//2
        
        self.answer_list = []
        
        self.mouse_label = pyglet.text.Label('Kill H1N1',
            font_name='Time New Roman',
            font_size=20,
            x = 620, y = 395, anchor_x="left", anchor_y="top", batch=self.batch)
            
        self.question_label = pyglet.text.Label('your question:',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 350, anchor_x="left", anchor_y="top", batch=self.batch)       
         
        self.sum_answer_label = pyglet.text.Label('your answer:',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 330, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.mouse_label = pyglet.text.Label('mouse here',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 310, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.hit_label = pyglet.text.Label('hit: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 290, anchor_x='left', anchor_y='top', batch=self.batch)
        
        self.flyer_alive_label = pyglet.text.Label('viruses alive: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 270, anchor_x='left', anchor_y='top', batch=self.batch)
            
        self.answer_label = pyglet.text.Label('hold: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 250, anchor_x='left', anchor_y='top', batch=self.batch)
            
        self.score_label = pyglet.text.Label('score: ',
            font_name='Time New Roman',
            font_size=10,
            x = 620, y = 230, anchor_x='left', anchor_y='top', batch=self.batch)
        
        # load image.
        self.mouse_image = pyglet.image.load('static/shoes.gif')
        self.mouse_get_off_image = pyglet.image.load('static/kill.gif')
#        self.mouse_thermometer = pyglet.image.load('static/thermometer_2.gif')
        
        self.cursor = pyglet.window.ImageMouseCursor(self.mouse_image, 45, 62)
        self.get_off_cursor = pyglet.window.ImageMouseCursor(self.mouse_get_off_image, 45, 62)
#        self.thermometer_cursor = pyglet.window.ImageMouseCursor(self.mouse_thermometer, 45, 62)
        
        self.default_cursor = self.get_system_mouse_cursor(self.CURSOR_DEFAULT)
        
        self.set_mouse_cursor(self.cursor)
        
        self.logo_sprite = game_Logo(batch=self.batch)
        self.xy = info_X_Y(self.batch)
        self.commit_buttom = commit_buttom()
        self.clear_buttom = clear_buttom()
        self.empty_buttom = empty_buttom()
        self.qa = question_and_answer()
        self.update_question()
        self.m_b = []
        self.create_Map_Block()
    
    def update_question(self):
        self.qa.make_a_question(level = self.level)
        self.question_label.text = 'question: %s' %self.qa.question_text
        self.q_a = self.qa.answer
 
    def create_Map_Block(self):
        point_x_y = self.xy.point_x_y_list
#        label_text_x_y = self.xy.label_text_list
        for n in range(0, len(point_x_y)):
            self.xy.package_screen_list(self.start_x, self.start_y)
#            mb = map_Block(image=self.xy.get_grass_images_list_from_x_y(x, y) ,batch=self.batch)
            mb = map_Block(batch=self.batch)
            mb.x = point_x_y[n][0]
            mb.y = point_x_y[n][1]
            i = random.randint(0,3)
#            mb.image = mb.grass[i]
            mb.label.x = mb.x + 175
            mb.label.y = mb.y + 175
            mb.label.text = self.xy.package_list[n].label             
            self.m_b.append(mb)
        
    def on_draw(self):
        if self.start_game:
            self.clear()
            self.batch.draw()
            for p in self.xy.point_x_y():
                draw_rect(p[0],p[1],200,200, filled=False)
            s_m_p = self.xy.small_point_x_y_list
            for n in range(0, len(s_m_p)):
                if self.xy.map_block_obj_list[n].flyer.alive:
                    draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=True)
                    self.xy.map_block_obj_list[n].flyer.draw()
                    pyglet.text.Label('%s' %self.xy.map_block_obj_list[n].flyer.number,
                        font_name='Time New Roman',
                        font_size=40,
                        bold = 1,
                        x = self.xy.map_block_obj_list[n].flyer.x + 100,
                        y = self.xy.map_block_obj_list[n].flyer.y).draw()
                else:
                    draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=False)
            draw_rect(610 + (self.start_x * 25), 410 + (self.start_y * 25), 75,75, line_width=5, filled=False)
            draw_line(625,165, 625 + (self.flyer_alive * 10), 165, line_width = 10)
            self.commit_buttom.draw()
            self.clear_buttom.draw()
            self.empty_buttom.draw()
        else:
            self.clear()
            self.game_start_batch.draw()
            self.viruses_logo.draw()

    
    # something key handler will re-add under here again.
    def on_key_press(self, symbol, modifiers):
        if symbol == key.ESCAPE:
            self.has_exit = True
        if symbol == key.W:
            if self.start_y < 4: self.start_y +=1
        if symbol == key.S:
            if self.start_y > 0: self.start_y -=1
        if symbol == key.D:
            if self.start_x < 4: self.start_x +=1
        if symbol == key.A:
            if self.start_x > 0: self.start_x -=1
    
    def on_mouse_press(self, x, y, button, modifiers):
        if self.start_game:
            if x < 600:
                self.set_mouse_cursor(self.get_off_cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
            for o in self.xy.map_block_obj_list:
                if o.flyer and self.hit_test(x, y, o.flyer):
                    self.mouse_label.text = 'hit'
                    o.flyer.alive = False
                    self.hit += 1
                    self.flyer_alive -= 1
                    self.hit_label.text = 'hit: %s' %self.hit
                    self.answer_list.append(o.flyer.number)
            if self.hit_test(x, y, self.empty_buttom):
                self.answer_list = []  
            if self.hit_test(x, y, self.clear_buttom):
                if len(self.answer_list):
                    self.answer_list.pop()
            self.update_answer_label_text()
            if self.hit_test(x, y, self.commit_buttom):
                sum = 0
                for n in self.answer_list:
                    sum += n
                if self.qa.answer == sum:
                    self.sum_answer_label.text = 'Your answer: %s (right)' %sum
                    self.score += self.qa.score
                    self.score_label.text = 'score: %s' %self.score
                    self.update_question()
                    self.level = self.score / 10
                else:
                    self.sum_answer_label.text = 'Your answer: %s (wong)' %sum
                self.answer_list = []
                self.update_answer_label_text()
                
        else:
            self.set_mouse_cursor(self.get_off_cursor)
            if  self.hit_test(x, y, self.viruses_logo):
                self.start_game = 1
                
    
    def on_mouse_motion(self, x, y, dx, dy):
#        if self.hit_test(x, y, self.logo_sprite):
#            self.set_mouse_cursor(self.thermometer_cursor)
#        else:
        if self.start_game:
            if x < 600:
                self.set_mouse_cursor(self.cursor)
            else:
                self.set_mouse_cursor(self.default_cursor)
        else:
            self.set_mouse_cursor(self.cursor)
        self.mouse_label.text = 'x=%s, y=%s' %(x, y)
    
    def on_mouse_release(self, x, y, button, modifiers):
        if x < 600:
            self.set_mouse_cursor(self.cursor)
        else:
            self.set_mouse_cursor(self.default_cursor)
        
    def hit_test(self, x, y, s):
        return (0 < x - s.x < s.width and
                0 < y - s.y < s.height)
    
    def update(self, dt):
        if self.start_game:
            for n in range(0, len(self.xy.point_x_y_list)):
                get_n = self.xy.package_screen_list(start_x=self.start_x, start_y=self.start_y)
                self.m_b[n].label.text = self.xy.package_list[n].label
                self.m_b[n].image = self.xy.package_list[n].block_image
            if self.flyer_alive > 10:
                self.set_mouse_visible(False)
                self.gameover_label = pyglet.text.Label('GAME OVER',
                    font_name='Time New Roman',
                    font_size=30,
                    x = 610, y = 220, anchor_x="left", anchor_y="top", batch=self.batch)
            self.flyer_alive_label.text = 'viruses alive: %s' %self.flyer_alive
            self.update_answer_label_text()
    
    def update_answer_label_text(self):
        if len(self.answer_list):
            self.answer_label.text = 'You hold: %s' %self.answer_list[0]
            if len(self.answer_list[1:]):
                for n in self.answer_list[1:]:
                    self.answer_label.text += ', ' + '%s' %n
        else:
            self.answer_label.text = 'You hold: '
            
        for n in range(0, 49):
#            if random.randint(0,1000) <= (self.flyer_alive / 50) + 1:
            if random.randint(0,3000) <= (1 + self.flyer_alive / 5):
                if not self.xy.map_block_obj_list[n].flyer.alive:
                    self.xy.map_block_obj_list[n].flyer.alive = True
                    self.flyer_alive += 1        